# -*- coding: utf-8 -*-

import getpass

def main():
    pass

class Interface:
    def __init__(self,app):
        self.app=app

    def on_start(self):
        print "Starting the scoreganizer client..."
        print "Leave ViennaSweeper open at your own risk."
        print "Closing it is very much recommended."
        print "(Assuming you currently have it open)."
        raw_input("Press <Enter> to continue...")
        return

    def on_need_https(self):
        print "You do not seems to be using the client over https, and"
        print "the server requires it."
        raw_input("Press <Enter> to exit...")

    def on_client_incompatible(self):
        print "Your client is incompatible, please download a new version."
        raw_input("Press <Enter> to exit...")

    def on_firststart(self):
        print "Starting the scoreganizer client for the first time..."

    def on_badlogin(self):
        print "Your login data doesn't work."
        print "Press <Enter> to try again, or input q to quit."

    def prompt_quit(self):
        if raw_input(">>> ")=="q":
            return True
        return False

    def on_logindata_outdated(self):
        print "Looks like your login data is outdated, have you changed"
        print "your password?"

    def prompt_reconfig(self):
        print "Press <Enter> to quit."
        print "Type \"newpassword\" or \"newp\" and press <Enter> to input"
        print "a new password."
        print "Type \"reconfigure\" or \"recf\" and press <Enter> to remove"
        print "your old saved login data and input your current data."
        res=raw_input(">>> ")
        if res in ("recf","reconfigure"):
            return "recf"
        if res in ("newp","newpassword"):
            return "newp"
        else:
            return False

    def on_login_successful(self):
        print "Login successful! New config saved."

    def on_connected_login_fail(self):
        print "Login failed. However, you are connected to the server,"
        print "and the network is almost certainly not the cause of"
        print "this problem."
        print "Make sure that you can login to the tournament site with"
        print "the data you provided here."

    def on_stored_login_success(self):
        print "Successfully using stored login data..."

    def on_get_key(self):
        print "Getting key for selected tournament..."
        print "If the tournament hasn't started yet, this will take until the"
        print "tournament starts."

    def on_got_key(self):
        print "Got key! ViennaSweeper should start any moment."

    def prompt_tournament(self,tournament_list,more=False):
        print "Please select a tournament to take part in from the list below"
        print "by giving the appropriate number as input."
        if not more:
            print "Or give \"m\" or \"more\" to get a longer list."
        print "Input \"q\" or \"quit\" to quit."
        ids=[]
        i=1
        i_to_id={}
        i_to_name={}
        for (t_id,name) in tournament_list:
            ids.append(t_id)
            i_to_id[i]=t_id
            i_to_name[i]=name
            print "["+str(i)+"] "+name
            i+=1
        while True:
            res=raw_input(">>> ")
            if res in ("m","more") and not more:
                return "m"
            if res in ("q","quit"):
                return False
            try:
                res=int(res)
                #check whether res was in the list
                i_to_name[res]
                i_to_id[res]
            except ValueError,IndexError:
                print "Please input "+("either " if not more else "")+\
                        "an integer from the list above"\
                        +(" or \"more\"" if not more else "")+"."
                print "Input \"q\" or \"quit\" to quit."
                continue
            return (i_to_id[res],i_to_name[res])

    def on_get_tournament_list(self):
        print "Getting tournament list..."

    def on_mainloop(self):
        print "Running..."
        print
        print "DO NOT CLOSE THIS WINDOW, OR YOUR SCORES WILL NOT BE UPLOADED."
        print
        print "If an error occurs, try starting the client again."

    def on_mainloop_end(self):
        print "Stopped."

    def print_connection_warning(self):
        print "Warning: Got a strange response from the server, are you"
        print "being redirected? Try connecting to the tournament service"
        print "using a web browser before you try again."

    def on_cannot_connect(self):
        print "Can't connect to the tournament service, are you online?"

    def prompt_retry_or_quit(self):
        print "Press <Enter> to retry, type \"q\" and press <Enter> to quit"
        res=raw_input(">>> ")
        if res=="q":
            return False
        return True

    def on_upload(self,vidfname):
        print "[uploading file]",vidfname

    def on_retrying(self):
        print "Got \"0 retry\", retrying..."

    def on_tournament_over(self):
        print "The tournament is over, your score was not uploaded."

    def on_invalid_data(self):
        print "Got 0 invalid_data for some reason... The score was probably uploaded already."

    def prompt_username(self):
        while True:
            username=raw_input("What is your scoreganizer username?\n")
            if not self.app.validate_username(username):
                print "Please enter a valid username!"
                continue
            break
        return username

    def prompt_password(self):
        password=getpass.getpass("Please enter your password (it won't be visible on-screen).\n")
        return password

    def on_vsweep_spawn_fail(self,e):
        if not e is None:
            print "Got an exception spawning vsweep, please try to start it yourself."
            print "Error message was:"
            print e.message
        print "This client can't launch vsweep on your system, please launch it yourself."


if __name__=="__main__":
    main()

